# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import SyncClientWrapper
from .resources.account_details.client import AccountDetailsClient
from .resources.account_token.client import AccountTokenClient
from .resources.accounting_periods.client import AccountingPeriodsClient
from .resources.accounts.client import AccountsClient
from .resources.addresses.client import AddressesClient
from .resources.async_passthrough.client import (
    AsyncPassthroughClient as resources_accounting_resources_async_passthrough_client_AsyncPassthroughClient,
)
from .resources.async_tasks.client import AsyncTasksClient
from .resources.attachments.client import AttachmentsClient
from .resources.audit_trail.client import AuditTrailClient
from .resources.available_actions.client import AvailableActionsClient
from .resources.balance_sheets.client import BalanceSheetsClient
from .resources.bank_feed_accounts.client import BankFeedAccountsClient
from .resources.bank_feed_transactions.client import BankFeedTransactionsClient
from .resources.cash_flow_statements.client import CashFlowStatementsClient
from .resources.company_info.client import CompanyInfoClient
from .resources.contacts.client import ContactsClient
from .resources.credit_notes.client import CreditNotesClient
from .resources.scopes.client import ScopesClient
from .resources.delete_account.client import DeleteAccountClient
from .resources.employees.client import EmployeesClient
from .resources.expenses.client import ExpensesClient
from .resources.field_mapping.client import FieldMappingClient
from .resources.general_ledger_transactions.client import GeneralLedgerTransactionsClient
from .resources.generate_key.client import GenerateKeyClient
from .resources.income_statements.client import IncomeStatementsClient
from .resources.invoices.client import InvoicesClient
from .resources.issues.client import IssuesClient
from .resources.items.client import ItemsClient
from .resources.journal_entries.client import JournalEntriesClient
from .resources.link_token.client import LinkTokenClient
from .resources.linked_accounts.client import LinkedAccountsClient
from .resources.passthrough.client import PassthroughClient
from .resources.payments.client import PaymentsClient
from .resources.phone_numbers.client import PhoneNumbersClient
from .resources.purchase_orders.client import PurchaseOrdersClient
from .resources.regenerate_key.client import RegenerateKeyClient
from .resources.sync_status.client import SyncStatusClient
from .resources.force_resync.client import ForceResyncClient
from .resources.tax_rates.client import TaxRatesClient
from .resources.tracking_categories.client import TrackingCategoriesClient
from .resources.transactions.client import TransactionsClient
from .resources.vendor_credits.client import VendorCreditsClient
from .resources.webhook_receivers.client import WebhookReceiversClient
from ...core.client_wrapper import AsyncClientWrapper
from .resources.account_details.client import AsyncAccountDetailsClient
from .resources.account_token.client import AsyncAccountTokenClient
from .resources.accounting_periods.client import AsyncAccountingPeriodsClient
from .resources.accounts.client import AsyncAccountsClient
from .resources.addresses.client import AsyncAddressesClient
from .resources.async_passthrough.client import AsyncAsyncPassthroughClient
from .resources.async_tasks.client import AsyncAsyncTasksClient
from .resources.attachments.client import AsyncAttachmentsClient
from .resources.audit_trail.client import AsyncAuditTrailClient
from .resources.available_actions.client import AsyncAvailableActionsClient
from .resources.balance_sheets.client import AsyncBalanceSheetsClient
from .resources.bank_feed_accounts.client import AsyncBankFeedAccountsClient
from .resources.bank_feed_transactions.client import AsyncBankFeedTransactionsClient
from .resources.cash_flow_statements.client import AsyncCashFlowStatementsClient
from .resources.company_info.client import AsyncCompanyInfoClient
from .resources.contacts.client import AsyncContactsClient
from .resources.credit_notes.client import AsyncCreditNotesClient
from .resources.scopes.client import AsyncScopesClient
from .resources.delete_account.client import AsyncDeleteAccountClient
from .resources.employees.client import AsyncEmployeesClient
from .resources.expenses.client import AsyncExpensesClient
from .resources.field_mapping.client import AsyncFieldMappingClient
from .resources.general_ledger_transactions.client import AsyncGeneralLedgerTransactionsClient
from .resources.generate_key.client import AsyncGenerateKeyClient
from .resources.income_statements.client import AsyncIncomeStatementsClient
from .resources.invoices.client import AsyncInvoicesClient
from .resources.issues.client import AsyncIssuesClient
from .resources.items.client import AsyncItemsClient
from .resources.journal_entries.client import AsyncJournalEntriesClient
from .resources.link_token.client import AsyncLinkTokenClient
from .resources.linked_accounts.client import AsyncLinkedAccountsClient
from .resources.passthrough.client import (
    AsyncPassthroughClient as resources_accounting_resources_passthrough_client_AsyncPassthroughClient,
)
from .resources.payments.client import AsyncPaymentsClient
from .resources.phone_numbers.client import AsyncPhoneNumbersClient
from .resources.purchase_orders.client import AsyncPurchaseOrdersClient
from .resources.regenerate_key.client import AsyncRegenerateKeyClient
from .resources.sync_status.client import AsyncSyncStatusClient
from .resources.force_resync.client import AsyncForceResyncClient
from .resources.tax_rates.client import AsyncTaxRatesClient
from .resources.tracking_categories.client import AsyncTrackingCategoriesClient
from .resources.transactions.client import AsyncTransactionsClient
from .resources.vendor_credits.client import AsyncVendorCreditsClient
from .resources.webhook_receivers.client import AsyncWebhookReceiversClient


class AccountingClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._client_wrapper = client_wrapper
        self.account_details = AccountDetailsClient(client_wrapper=self._client_wrapper)
        self.account_token = AccountTokenClient(client_wrapper=self._client_wrapper)
        self.accounting_periods = AccountingPeriodsClient(client_wrapper=self._client_wrapper)
        self.accounts = AccountsClient(client_wrapper=self._client_wrapper)
        self.addresses = AddressesClient(client_wrapper=self._client_wrapper)
        self.async_passthrough = resources_accounting_resources_async_passthrough_client_AsyncPassthroughClient(
            client_wrapper=self._client_wrapper
        )
        self.async_tasks = AsyncTasksClient(client_wrapper=self._client_wrapper)
        self.attachments = AttachmentsClient(client_wrapper=self._client_wrapper)
        self.audit_trail = AuditTrailClient(client_wrapper=self._client_wrapper)
        self.available_actions = AvailableActionsClient(client_wrapper=self._client_wrapper)
        self.balance_sheets = BalanceSheetsClient(client_wrapper=self._client_wrapper)
        self.bank_feed_accounts = BankFeedAccountsClient(client_wrapper=self._client_wrapper)
        self.bank_feed_transactions = BankFeedTransactionsClient(client_wrapper=self._client_wrapper)
        self.cash_flow_statements = CashFlowStatementsClient(client_wrapper=self._client_wrapper)
        self.company_info = CompanyInfoClient(client_wrapper=self._client_wrapper)
        self.contacts = ContactsClient(client_wrapper=self._client_wrapper)
        self.credit_notes = CreditNotesClient(client_wrapper=self._client_wrapper)
        self.scopes = ScopesClient(client_wrapper=self._client_wrapper)
        self.delete_account = DeleteAccountClient(client_wrapper=self._client_wrapper)
        self.employees = EmployeesClient(client_wrapper=self._client_wrapper)
        self.expenses = ExpensesClient(client_wrapper=self._client_wrapper)
        self.field_mapping = FieldMappingClient(client_wrapper=self._client_wrapper)
        self.general_ledger_transactions = GeneralLedgerTransactionsClient(client_wrapper=self._client_wrapper)
        self.generate_key = GenerateKeyClient(client_wrapper=self._client_wrapper)
        self.income_statements = IncomeStatementsClient(client_wrapper=self._client_wrapper)
        self.invoices = InvoicesClient(client_wrapper=self._client_wrapper)
        self.issues = IssuesClient(client_wrapper=self._client_wrapper)
        self.items = ItemsClient(client_wrapper=self._client_wrapper)
        self.journal_entries = JournalEntriesClient(client_wrapper=self._client_wrapper)
        self.link_token = LinkTokenClient(client_wrapper=self._client_wrapper)
        self.linked_accounts = LinkedAccountsClient(client_wrapper=self._client_wrapper)
        self.passthrough = PassthroughClient(client_wrapper=self._client_wrapper)
        self.payments = PaymentsClient(client_wrapper=self._client_wrapper)
        self.phone_numbers = PhoneNumbersClient(client_wrapper=self._client_wrapper)
        self.purchase_orders = PurchaseOrdersClient(client_wrapper=self._client_wrapper)
        self.regenerate_key = RegenerateKeyClient(client_wrapper=self._client_wrapper)
        self.sync_status = SyncStatusClient(client_wrapper=self._client_wrapper)
        self.force_resync = ForceResyncClient(client_wrapper=self._client_wrapper)
        self.tax_rates = TaxRatesClient(client_wrapper=self._client_wrapper)
        self.tracking_categories = TrackingCategoriesClient(client_wrapper=self._client_wrapper)
        self.transactions = TransactionsClient(client_wrapper=self._client_wrapper)
        self.vendor_credits = VendorCreditsClient(client_wrapper=self._client_wrapper)
        self.webhook_receivers = WebhookReceiversClient(client_wrapper=self._client_wrapper)


class AsyncAccountingClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._client_wrapper = client_wrapper
        self.account_details = AsyncAccountDetailsClient(client_wrapper=self._client_wrapper)
        self.account_token = AsyncAccountTokenClient(client_wrapper=self._client_wrapper)
        self.accounting_periods = AsyncAccountingPeriodsClient(client_wrapper=self._client_wrapper)
        self.accounts = AsyncAccountsClient(client_wrapper=self._client_wrapper)
        self.addresses = AsyncAddressesClient(client_wrapper=self._client_wrapper)
        self.async_passthrough = AsyncAsyncPassthroughClient(client_wrapper=self._client_wrapper)
        self.async_tasks = AsyncAsyncTasksClient(client_wrapper=self._client_wrapper)
        self.attachments = AsyncAttachmentsClient(client_wrapper=self._client_wrapper)
        self.audit_trail = AsyncAuditTrailClient(client_wrapper=self._client_wrapper)
        self.available_actions = AsyncAvailableActionsClient(client_wrapper=self._client_wrapper)
        self.balance_sheets = AsyncBalanceSheetsClient(client_wrapper=self._client_wrapper)
        self.bank_feed_accounts = AsyncBankFeedAccountsClient(client_wrapper=self._client_wrapper)
        self.bank_feed_transactions = AsyncBankFeedTransactionsClient(client_wrapper=self._client_wrapper)
        self.cash_flow_statements = AsyncCashFlowStatementsClient(client_wrapper=self._client_wrapper)
        self.company_info = AsyncCompanyInfoClient(client_wrapper=self._client_wrapper)
        self.contacts = AsyncContactsClient(client_wrapper=self._client_wrapper)
        self.credit_notes = AsyncCreditNotesClient(client_wrapper=self._client_wrapper)
        self.scopes = AsyncScopesClient(client_wrapper=self._client_wrapper)
        self.delete_account = AsyncDeleteAccountClient(client_wrapper=self._client_wrapper)
        self.employees = AsyncEmployeesClient(client_wrapper=self._client_wrapper)
        self.expenses = AsyncExpensesClient(client_wrapper=self._client_wrapper)
        self.field_mapping = AsyncFieldMappingClient(client_wrapper=self._client_wrapper)
        self.general_ledger_transactions = AsyncGeneralLedgerTransactionsClient(client_wrapper=self._client_wrapper)
        self.generate_key = AsyncGenerateKeyClient(client_wrapper=self._client_wrapper)
        self.income_statements = AsyncIncomeStatementsClient(client_wrapper=self._client_wrapper)
        self.invoices = AsyncInvoicesClient(client_wrapper=self._client_wrapper)
        self.issues = AsyncIssuesClient(client_wrapper=self._client_wrapper)
        self.items = AsyncItemsClient(client_wrapper=self._client_wrapper)
        self.journal_entries = AsyncJournalEntriesClient(client_wrapper=self._client_wrapper)
        self.link_token = AsyncLinkTokenClient(client_wrapper=self._client_wrapper)
        self.linked_accounts = AsyncLinkedAccountsClient(client_wrapper=self._client_wrapper)
        self.passthrough = resources_accounting_resources_passthrough_client_AsyncPassthroughClient(
            client_wrapper=self._client_wrapper
        )
        self.payments = AsyncPaymentsClient(client_wrapper=self._client_wrapper)
        self.phone_numbers = AsyncPhoneNumbersClient(client_wrapper=self._client_wrapper)
        self.purchase_orders = AsyncPurchaseOrdersClient(client_wrapper=self._client_wrapper)
        self.regenerate_key = AsyncRegenerateKeyClient(client_wrapper=self._client_wrapper)
        self.sync_status = AsyncSyncStatusClient(client_wrapper=self._client_wrapper)
        self.force_resync = AsyncForceResyncClient(client_wrapper=self._client_wrapper)
        self.tax_rates = AsyncTaxRatesClient(client_wrapper=self._client_wrapper)
        self.tracking_categories = AsyncTrackingCategoriesClient(client_wrapper=self._client_wrapper)
        self.transactions = AsyncTransactionsClient(client_wrapper=self._client_wrapper)
        self.vendor_credits = AsyncVendorCreditsClient(client_wrapper=self._client_wrapper)
        self.webhook_receivers = AsyncWebhookReceiversClient(client_wrapper=self._client_wrapper)
