# This file was auto-generated by Fern from our API Definition.

from ....core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import datetime as dt
from .patched_task_request_status import PatchedTaskRequestStatus
from .remote_field_request import RemoteFieldRequest
from ....core.pydantic_utilities import IS_PYDANTIC_V2


class PatchedTaskRequest(UniversalBaseModel):
    """
    # The Task Object

    ### Description

    The `Task` object is used to represent a task, such as a to-do item.

    ### Usage Example

    TODO
    """

    subject: typing.Optional[str] = pydantic.Field(default=None)
    """
    The task's subject.
    """

    content: typing.Optional[str] = pydantic.Field(default=None)
    """
    The task's content.
    """

    owner: typing.Optional[str] = pydantic.Field(default=None)
    """
    The task's owner.
    """

    account: typing.Optional[str] = pydantic.Field(default=None)
    """
    The task's account.
    """

    opportunity: typing.Optional[str] = pydantic.Field(default=None)
    """
    The task's opportunity.
    """

    completed_date: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    When the task is completed.
    """

    due_date: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    When the task is due.
    """

    status: typing.Optional[PatchedTaskRequestStatus] = pydantic.Field(default=None)
    """
    The task's status.
    
    - `OPEN` - OPEN
    - `CLOSED` - CLOSED
    """

    integration_params: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = None
    linked_account_params: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = None
    remote_fields: typing.Optional[typing.List[RemoteFieldRequest]] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
