# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
from ....core.pydantic_utilities import UniversalBaseModel
from .employee import Employee
from .employment import Employment
from .team import Team
import typing
from .timesheet_entry_request_employee import TimesheetEntryRequestEmployee
import pydantic
import datetime as dt
from ....core.pydantic_utilities import IS_PYDANTIC_V2
from ....core.pydantic_utilities import update_forward_refs


class TimesheetEntryRequest(UniversalBaseModel):
    """
    # The Timesheet Entry Object

    ### Description

    The `Timesheet Entry` object is used to track coverage for hours worked by an 'Employee'.

    ### Usage Example

    GET and POST Timesheet Entries
    """

    employee: typing.Optional[TimesheetEntryRequestEmployee] = pydantic.Field(default=None)
    """
    The employee the timesheet entry is for.
    """

    hours_worked: typing.Optional[float] = pydantic.Field(default=None)
    """
    The number of hours logged by the employee.
    """

    start_time: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    The time at which the employee started work.
    """

    end_time: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    The time at which the employee ended work.
    """

    integration_params: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = None
    linked_account_params: typing.Optional[typing.Dict[str, typing.Optional[typing.Any]]] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


update_forward_refs(Employee, TimesheetEntryRequest=TimesheetEntryRequest)
update_forward_refs(Employment, TimesheetEntryRequest=TimesheetEntryRequest)
update_forward_refs(Team, TimesheetEntryRequest=TimesheetEntryRequest)
