# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import SyncClientWrapper
from .resources.account_details.client import AccountDetailsClient
from .resources.account_token.client import AccountTokenClient
from .resources.accounts.client import AccountsClient
from .resources.async_passthrough.client import (
    AsyncPassthroughClient as resources_ticketing_resources_async_passthrough_client_AsyncPassthroughClient,
)
from .resources.attachments.client import AttachmentsClient
from .resources.audit_trail.client import AuditTrailClient
from .resources.available_actions.client import AvailableActionsClient
from .resources.collections.client import CollectionsClient
from .resources.comments.client import CommentsClient
from .resources.contacts.client import ContactsClient
from .resources.scopes.client import ScopesClient
from .resources.delete_account.client import DeleteAccountClient
from .resources.field_mapping.client import FieldMappingClient
from .resources.generate_key.client import GenerateKeyClient
from .resources.issues.client import IssuesClient
from .resources.link_token.client import LinkTokenClient
from .resources.linked_accounts.client import LinkedAccountsClient
from .resources.passthrough.client import PassthroughClient
from .resources.projects.client import ProjectsClient
from .resources.regenerate_key.client import RegenerateKeyClient
from .resources.roles.client import RolesClient
from .resources.sync_status.client import SyncStatusClient
from .resources.force_resync.client import ForceResyncClient
from .resources.tags.client import TagsClient
from .resources.teams.client import TeamsClient
from .resources.tickets.client import TicketsClient
from .resources.users.client import UsersClient
from .resources.webhook_receivers.client import WebhookReceiversClient
from ...core.client_wrapper import AsyncClientWrapper
from .resources.account_details.client import AsyncAccountDetailsClient
from .resources.account_token.client import AsyncAccountTokenClient
from .resources.accounts.client import AsyncAccountsClient
from .resources.async_passthrough.client import AsyncAsyncPassthroughClient
from .resources.attachments.client import AsyncAttachmentsClient
from .resources.audit_trail.client import AsyncAuditTrailClient
from .resources.available_actions.client import AsyncAvailableActionsClient
from .resources.collections.client import AsyncCollectionsClient
from .resources.comments.client import AsyncCommentsClient
from .resources.contacts.client import AsyncContactsClient
from .resources.scopes.client import AsyncScopesClient
from .resources.delete_account.client import AsyncDeleteAccountClient
from .resources.field_mapping.client import AsyncFieldMappingClient
from .resources.generate_key.client import AsyncGenerateKeyClient
from .resources.issues.client import AsyncIssuesClient
from .resources.link_token.client import AsyncLinkTokenClient
from .resources.linked_accounts.client import AsyncLinkedAccountsClient
from .resources.passthrough.client import (
    AsyncPassthroughClient as resources_ticketing_resources_passthrough_client_AsyncPassthroughClient,
)
from .resources.projects.client import AsyncProjectsClient
from .resources.regenerate_key.client import AsyncRegenerateKeyClient
from .resources.roles.client import AsyncRolesClient
from .resources.sync_status.client import AsyncSyncStatusClient
from .resources.force_resync.client import AsyncForceResyncClient
from .resources.tags.client import AsyncTagsClient
from .resources.teams.client import AsyncTeamsClient
from .resources.tickets.client import AsyncTicketsClient
from .resources.users.client import AsyncUsersClient
from .resources.webhook_receivers.client import AsyncWebhookReceiversClient


class TicketingClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._client_wrapper = client_wrapper
        self.account_details = AccountDetailsClient(client_wrapper=self._client_wrapper)
        self.account_token = AccountTokenClient(client_wrapper=self._client_wrapper)
        self.accounts = AccountsClient(client_wrapper=self._client_wrapper)
        self.async_passthrough = resources_ticketing_resources_async_passthrough_client_AsyncPassthroughClient(
            client_wrapper=self._client_wrapper
        )
        self.attachments = AttachmentsClient(client_wrapper=self._client_wrapper)
        self.audit_trail = AuditTrailClient(client_wrapper=self._client_wrapper)
        self.available_actions = AvailableActionsClient(client_wrapper=self._client_wrapper)
        self.collections = CollectionsClient(client_wrapper=self._client_wrapper)
        self.comments = CommentsClient(client_wrapper=self._client_wrapper)
        self.contacts = ContactsClient(client_wrapper=self._client_wrapper)
        self.scopes = ScopesClient(client_wrapper=self._client_wrapper)
        self.delete_account = DeleteAccountClient(client_wrapper=self._client_wrapper)
        self.field_mapping = FieldMappingClient(client_wrapper=self._client_wrapper)
        self.generate_key = GenerateKeyClient(client_wrapper=self._client_wrapper)
        self.issues = IssuesClient(client_wrapper=self._client_wrapper)
        self.link_token = LinkTokenClient(client_wrapper=self._client_wrapper)
        self.linked_accounts = LinkedAccountsClient(client_wrapper=self._client_wrapper)
        self.passthrough = PassthroughClient(client_wrapper=self._client_wrapper)
        self.projects = ProjectsClient(client_wrapper=self._client_wrapper)
        self.regenerate_key = RegenerateKeyClient(client_wrapper=self._client_wrapper)
        self.roles = RolesClient(client_wrapper=self._client_wrapper)
        self.sync_status = SyncStatusClient(client_wrapper=self._client_wrapper)
        self.force_resync = ForceResyncClient(client_wrapper=self._client_wrapper)
        self.tags = TagsClient(client_wrapper=self._client_wrapper)
        self.teams = TeamsClient(client_wrapper=self._client_wrapper)
        self.tickets = TicketsClient(client_wrapper=self._client_wrapper)
        self.users = UsersClient(client_wrapper=self._client_wrapper)
        self.webhook_receivers = WebhookReceiversClient(client_wrapper=self._client_wrapper)


class AsyncTicketingClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._client_wrapper = client_wrapper
        self.account_details = AsyncAccountDetailsClient(client_wrapper=self._client_wrapper)
        self.account_token = AsyncAccountTokenClient(client_wrapper=self._client_wrapper)
        self.accounts = AsyncAccountsClient(client_wrapper=self._client_wrapper)
        self.async_passthrough = AsyncAsyncPassthroughClient(client_wrapper=self._client_wrapper)
        self.attachments = AsyncAttachmentsClient(client_wrapper=self._client_wrapper)
        self.audit_trail = AsyncAuditTrailClient(client_wrapper=self._client_wrapper)
        self.available_actions = AsyncAvailableActionsClient(client_wrapper=self._client_wrapper)
        self.collections = AsyncCollectionsClient(client_wrapper=self._client_wrapper)
        self.comments = AsyncCommentsClient(client_wrapper=self._client_wrapper)
        self.contacts = AsyncContactsClient(client_wrapper=self._client_wrapper)
        self.scopes = AsyncScopesClient(client_wrapper=self._client_wrapper)
        self.delete_account = AsyncDeleteAccountClient(client_wrapper=self._client_wrapper)
        self.field_mapping = AsyncFieldMappingClient(client_wrapper=self._client_wrapper)
        self.generate_key = AsyncGenerateKeyClient(client_wrapper=self._client_wrapper)
        self.issues = AsyncIssuesClient(client_wrapper=self._client_wrapper)
        self.link_token = AsyncLinkTokenClient(client_wrapper=self._client_wrapper)
        self.linked_accounts = AsyncLinkedAccountsClient(client_wrapper=self._client_wrapper)
        self.passthrough = resources_ticketing_resources_passthrough_client_AsyncPassthroughClient(
            client_wrapper=self._client_wrapper
        )
        self.projects = AsyncProjectsClient(client_wrapper=self._client_wrapper)
        self.regenerate_key = AsyncRegenerateKeyClient(client_wrapper=self._client_wrapper)
        self.roles = AsyncRolesClient(client_wrapper=self._client_wrapper)
        self.sync_status = AsyncSyncStatusClient(client_wrapper=self._client_wrapper)
        self.force_resync = AsyncForceResyncClient(client_wrapper=self._client_wrapper)
        self.tags = AsyncTagsClient(client_wrapper=self._client_wrapper)
        self.teams = AsyncTeamsClient(client_wrapper=self._client_wrapper)
        self.tickets = AsyncTicketsClient(client_wrapper=self._client_wrapper)
        self.users = AsyncUsersClient(client_wrapper=self._client_wrapper)
        self.webhook_receivers = AsyncWebhookReceiversClient(client_wrapper=self._client_wrapper)
